import { world } from "@minecraft/server";

export class ItemManager {
    static init() {
        world.beforeEvents.worldInitialize.subscribe(initEvent => {
            initEvent.itemComponentRegistry.registerCustomComponent('crucifix:trigger', {
                onUse: e => {
                    const weightedFunctions = [
                        { command: "function crucifix1", weight: 4 },
                        { command: "function crucifix2", weight: 1 }
                    ];

                    const weightedPool = [];
                    weightedFunctions.forEach(item => {
                        for (let i = 0; i < item.weight; i++) {
                            weightedPool.push(item.command);
                        }
                    });

                    const randomFunction = weightedPool[Math.floor(Math.random() * weightedPool.length)];
                    e.source.runCommand(randomFunction);
                },
            });

            initEvent.itemComponentRegistry.registerCustomComponent('imageofchrist:trigger', {
                onUse: e => {
                    const weightedFunctions = [
                        { command: "function image1", weight: 3 },
                        { command: "function image2", weight: 3 },
                        { command: "function image3", weight: 3 },
                        { command: "function image4", weight: 3 },
                        { command: "function image5", weight: 1 }
                    ];

                    const weightedPool = [];
                    weightedFunctions.forEach(item => {
                        for (let i = 0; i < item.weight; i++) {
                            weightedPool.push(item.command);
                        }
                    });

                    const randomFunction = weightedPool[Math.floor(Math.random() * weightedPool.length)];
                    e.source.runCommand(randomFunction);
                },
            });

            initEvent.itemComponentRegistry.registerCustomComponent('holywater:trigger', {
                onConsume: e => {
                    e.source.addEffect("minecraft:regeneration", 600, { amplifier: 0 });
                    e.source.addEffect("minecraft:resistance", 200, { amplifier: 0 });
                    e.source.addEffect("minecraft:saturation", 600, { amplifier: 0 });

                    e.source.removeEffect("minecraft:weakness");
                    e.source.removeEffect("minecraft:wither");
                    e.source.removeEffect("minecraft:slowness");
                    e.source.removeEffect("minecraft:poison");
                    e.source.removeEffect("minecraft:nausea");
                    e.source.removeEffect("minecraft:mining_fatigue");
                    e.source.removeEffect("minecraft:instant_damage");
                    e.source.removeEffect("minecraft:hunger");
                    e.source.removeEffect("minecraft:fatal_poison");
                    e.source.removeEffect("minecraft:blindness");
                },
            });
        });
    }
}